;la toate macro in afara de cea pentru data si cea pentru cnp, lungimea sirului trb sa fie 20


;;rez va fi 0 dc sirul contine doar lit mici, urmate de blanc-uri (optional)
;;1 in caz contrar
;;un sir de blancu-uri nu e valid, si el trb sa inceapa obl. cu lit mica
lit_mici MACRO sir, rez
local bucla_lit, bucla_bl, fals, gata
	push cx
	push si
	cmp sir[0],' '
	je fals
	xor si, si
	mov rez, 0    		      
	mov cx, 20	
	bucla_lit:
		cmp sir[si],'a'
		jl bucla_bl
		cmp sir[si],'z'
		jg bucla_bl
		inc si
		loop bucla_lit
	jmp gata
	bucla_bl:
		cmp sir[si],' '
		jne fals
		inc si
		loop bucla_bl
	jmp gata
	fals:
		mov rez, 1
	gata:
	pop si	
	pop cx
ENDM

;;rez va fi 0 dc sirul contine doar litere mari,urmate (optional) de blanc-uri, 1 in caz contrar
;;un sir de blancu-uri nu e valid
lit_mari MACRO sir,rez
local bucla_lit, bucla_bl, fals, gata
	push si
	cmp sir[0],' '
	je fals
	xor si,si        
	mov rez, 0    
	bucla_lit:
		cmp sir[si],'A'
		jl bucla_bl
		cmp sir[si],'Z'
		jg bucla_bl
		inc si
		cmp si,20
		jl bucla_lit
		jmp gata
	bucla_bl:
		cmp sir[si],' '
		jne fals
		inc si
		cmp si,20
		jl bucla_bl		
		jmp gata
	fals:
		mov rez, 1
	gata:
	pop si
ENDM



;;rez va fi 0 dc sirul contine doar litere mici sau mari, urmate optional de blanc-uri
;; 1 in caz contrar
;;un sir de blanc-uri nu e valid
lit_mari_mici MACRO sir, rez
local test_lit_mi, test_lit_ma, test_bl, fals, gata
	push si
	cmp sir[0],' '
	je fals
	mov rez, 0		   
    xor si,si
    test_lit_mi:
		cmp sir[si], 'a'
		jl test_lit_ma
		cmp sir[si], 'z'
		jg test_lit_ma
		inc si
		cmp si, 20
		jl test_lit_mi
		jge gata
	test_lit_ma:
		cmp sir[si], 'A'
		jl test_bl
		cmp sir[si], 'Z'
		jg test_bl
		inc si
		cmp si, 20
		jl test_lit_mi
		jge gata
	test_bl:
		cmp sir[si], ' '
		jne fals
		inc si
		cmp si,20
		jl test_bl
		jge gata
	fals:
		mov rez, 1
	gata:
	pop si
ENDM

;;intreg fara semn, precedat de blanc-uri 
;;trb sa contina cel putin o cifra - doar blanc-uri => incorect (rez=1)
;;rez e 0 dc e numar intreg fara semn, 1 in caz contrar
intr_fs_lead_bl MACRO sir, rez
local test_bl, test_cf,test_cf_1, fals, gata
	push si

	mov rez, 0
	xor si,si
	test_bl:
		cmp sir[si], ' '
		jne test_cf_1
		inc si
		cmp si, 19 ;;verificam doar (max) 19 blanc-uri, pt ca trb sa avem cel putin o cifra
		jl test_bl
	test_cf_1:
		cmp si,19
		je test_cf
		cmp sir[si], '1'	
		jb fals
		cmp sir[si], '9'
		ja fals
		inc si

	test_cf:
		cmp sir[si], '0'
		jb fals
		cmp sir[si], '9'
		ja fals
		inc si
		cmp si,20
		jl test_cf
		jge gata
	fals:
		mov rez, 1
	gata:		
	pop si
ENDM


;;intreg fara semn, precedat de 0-uri 
;;dc avem doar 0-uri, se considera valid
;;rez e 0 pentru intreg fara semn precedat de 0-uri
;;1 in caz contrar
intr_fs_lead_0 MACRO sir, rez
local test_0, test_cf, fals, gata
	push si
	mov rez, 0
	xor si,si
	test_cf:
		cmp sir[si],'0'
		jl fals
		cmp sir[si],'9'
		jg fals
		inc si
		cmp si,20
		jl test_cf
		jge gata
	fals:
		mov rez, 1
	gata:		
	pop si
ENDM



;;intreg cu semn , precedat de blanc-uri
;;numarul propriu - zis poate avea in fata +, - , sau blanc. nu poate incepe cu 0
;;dc sunt doar blanc-uri nu este corect
;;rez e 0 pt numar valid, 1 in caz contrar
;;nr nu poate incepe cu 0, decat dc e +0.-0 sau 0
intr_cs MACRO sir,rez
local test_bl, test_p, test_cf, test_cifra_1, fals, gata, increm
	push si
	mov rez, 0
	xor si,si
	test_bl:
		cmp sir[si], ' '
		jne test_p
		inc si
		cmp si,19
		jl test_bl
		jge test_p
	test_p:
		cmp sir[si], '+'
		je increm
		cmp sir[si], '-'
		je increm
		jmp test_cifra_1 ;;daca nu e nici plus nici minus, verificam sa nu fie 0	
	increm:
		inc si
	test_cifra_1:
		cmp si,19
		je test_cf
		cmp sir[si], '0'
		je fals
	test_cf:
		cmp sir[si], '0'
		jb fals
		cmp sir[si], '9'
		ja fals
		inc si
		cmp si,20
		jl test_cf
		jge gata
	fals:
		mov rez, 1
	gata:		
	pop si
ENDM



;;verifica daca stringul dat reprezinta un intreg cu semn, si daca da, face conversia la un intreg
;;numarul ca string poate fi precedat de blanc-uri. si optional de un + sau un -
;;dc s-a putut face conversia, rez are valoarea 0, iar numarul convertit este pus la adresa nr, ocupand 2 octeti
;;dc nu s-a putut face conversia rez este 1, iar valoarea depusa la nr nu este valida
;;considerand ca ne intereseaza mai mult conversia, numarul poate incepe cu 0-uri
to_intr_cs MACRO sir,rez,nr
local test_bl, test_p, increm, init, test_cf, fals, gata
push ax
push bx
push cx
push dx ;;??am fol dx?
push si
push di
	mov rez, 0
	mov di,1
	xor si,si
	test_bl:
		cmp sir[si], ' '
		jne test_p
		inc si
		cmp si,19
		jl test_bl
	test_p:
		cmp sir[si], '+'
		je increm
		cmp sir[si], '-'
		jne init
		mov di, -1
	increm:
		inc si
	init:
		xor ax,ax
		xor ch,ch
		mov bx,10
	test_cf:
		cmp sir[si], '0'
		jb fals
		cmp sir[si], '9'
		ja fals
		mul bx
		mov cl,sir[si]
		sub cl,'0'
		add ax,cx
		inc si
		cmp si,20
		jl test_cf
		
		cmp di,-1
		jne gata
		neg ax
		jmp gata
	fals:
		mov rez, 1
	gata:
		mov nr, ax
pop di
pop si
pop dx
pop cx
pop bx
pop ax
ENDM
	

;;linf<=integer(nr)<=lsup
;;trebuie ca  linf , lsup >=0,intregi si linf>lsup
;;verificam daca un numar dat ca sir, apartine intervalui specificat de nr: linf, lsup
;;rez e 0 dc sirul s-a putut converti la numar, si apartine intervalului
;;rez e 1 dc nu s-a putut face conversia
;;rez e 2 dc s-a putut face conversia, dar numarul nu apartine intervalui
interval MACRO sir, rez, linf, lsup, nr
to_intr_cs sir,rez,nr
cmp rez,1 ;;nu s-a putut face conversia
je gata
cmp nr,0 ;;dc nr e <0, cum capetele intervalului sunt pozitive, inseamna k nr nu apartine intervalului
jl fals
cmp nr, linf
jl fals
cmp nr, lsup
jg fals
jmp gata
fals:
	mov rez, 2 ;;dc rez e 2, s-a putut face conversia, dar nr nu apartine intervalului	
gata:
ENDM


;;identificator format din litere mari sau mici urmate de blancuri
;;rez e 0 pt identificator corect
;;1 in caz contrar
id_lit_mari_mici MACRO sir, rez
lit_mari_mici sir,rez
ENDM



;;identificator format din litera mica, sau mare, urmata de cifre, litere mici sau mari, apoi blanc-uri
;;rez e 0 pt identificator corect
;;1 in caz contrar
;;un sir de blanc-uri nu e valid. trb sa aiba obligatoriu litera mica sau mare
id_lit_cf_lit MACRO sir, rez
local test_l_mica,test_l_mare, test_bl, test_cf, fals, gata
	push si
	mov si,0
	mov rez, 0
	test_l_mica:
		cmp sir[si], 'a'
		jl test_l_mare
		cmp sir[si], 'z'
		jg test_l_mare
		inc si
		cmp si, 20
		jl test_l_mica
		jmp gata
	test_l_mare:
		cmp sir[si], 'A'
		jl test_cf
		cmp sir[si], 'Z'
		jg test_cf
		inc si
		cmp si, 20
		jl test_l_mica
		jmp gata
	test_cf:
		cmp si,0
		je fals
		cmp sir[si], '0'
		jl test_bl
		cmp sir[si], '9'
		jg test_bl
		inc si
		cmp si,20
		jl test_l_mica
		jmp gata
	test_bl:
		cmp sir[si], ' '
		jne fals
		inc si
		cmp si, 20
		jl test_bl
		jmp gata
	fals:
		mov rez, 1
	gata:
		pop si
ENDM


;;identificator format din litera mica, sau mare, urmata de cifre, litere mici, mari sau _, apoi blanc-uri
;;rez e 0 pt identificator corect
;;1 in caz contrar
;;un sir de blanc-uri nu e valid. trb sa aiba obligatoriu litera mica sau mare
id_lit_cf_lit__ MACRO sir, rez
local test_l_mica,test_l_mare, test_bl,test__, test_cf, fals, gata
	push si
	mov si,0
	mov rez, 0
	test_l_mica:
		cmp sir[si], 'a'
		jl test_l_mare
		cmp sir[si], 'z'
		jg test_l_mare
		inc si
		cmp si, 20
		jl test_l_mica
		jmp gata
	test_l_mare:
		cmp sir[si], 'A'
		jl test_cf
		cmp sir[si], 'Z'
		jg test_cf
		inc si
		cmp si, 20
		jl test_l_mica
		jmp gata
	test_cf:
		cmp si,0
		je fals
		cmp sir[si], '0'
		jl test__
		cmp sir[si], '9'
		jg test__
		inc si
		cmp si,20
		jl test_l_mica
		jmp gata
	test__:
		cmp si, 0
		je fals
		cmp sir[si],'_'
		jne test_bl
		inc si
		cmp si,20
		jl test_l_mica
		jmp gata
	test_bl:
		cmp sir[si], ' '
		jne fals
		inc si
		cmp si, 20
		jl test_bl
		jmp gata
	fals:
		mov rez, 1
	gata:
		pop si
ENDM


;;valideaza o data in format an(2 cifre) - luna -zi, deci sirul trb sa aiba lungimea 6
;;rez e 0 dc data e valida
;;1 in caz contrar
data_aallzz MACRO sir,rez
local luna_0, luna_1, luna_2, test_30_31,et_30, test_30, test_31, zi, fals, gata, interm
	push ax
	push bx
	push cx
	push dx
	push si
	push di
	
	mov rez,0
	xor ah,ah
	mov dl,0  ;;dl e 0 dc nu e an bisect
	
	cmp sir[0],'0'
	jb interm
	cmp sir[0],'9'
	ja interm
	mov al,sir[0]
	sub al,'0'
	mov bl,10
	mul bl
		
	cmp sir[1],'0'
	jb interm
	cmp sir[1],'9'
	ja interm
	mov cl,sir[1]
	sub cl,'0'
	add al,cl
	mov bl,4
	div bl   ;;verificam dc anul, ale carui ult e cifre sunt in al e bisect
	cmp ah,0 ;;restul imp e in ah
	jne luna_0 ;;dc anul nu e bisect, dl ramane 0
	inc dl   ;;dc anul e bisect, facem dl 1
	
luna_0:
	cmp sir[2],'0'
	jne luna_1
	xor ax,ax ;;dc luna are 0 prima cifra punem in al 0
	jmp luna_2  ;;si verificam ce-a de-a 2-a cifra a lunii
luna_1:
	cmp sir[2],'1' 
	jne interm ;;dc prima cifra a lunii nu e nici 0 nici 1, data nu e corecta
	mov al,10
luna_2:
	cmp sir[3],'0'
	jb interm
	cmp sir[3],'9'
	ja interm
	mov cl, sir[3]
	sub cl,'0'
	add al,cl ;;acum avem luna in al
	cmp al,0
	je interm
	cmp al,12
	jg interm
	mov ch,1 ;;punem in ch 1 dc luna va avea 31 zile
	cmp al,2 ;;vedem dc luna e februarie
	jne test_30_31
	mov ch,2 ;;punem in ch 2 dc luna e feb,si sarim la calcul zi
	jmp zi
interm:
	jmp fals	
test_30_31:	
	;;vrem avem ch ==0 dc luna are 30 zile, si ch==1 dc luna are 31 zile
	cmp al,4
	je et_30
	cmp al, 6
	je et_30
	cmp al, 9
	je et_30
	cmp al,11
	je et_30
	jmp zi

et_30:
	xor ch,ch ;;punem in ch 0, pt k luna are 30 zile
zi:	
	cmp sir[4],'0'
	jb fals
	cmp sir[4],'9'
	ja fals
	mov al,sir[4]
	sub al,'0'
	mov bl,10
	mul bl
	cmp sir[5],'0'
	jb fals
	cmp sir[5],'9'
	ja fals
	mov cl,sir[5]
	sub cl,'0'
	add al,cl  ;;acum avem ziua in al
	cmp al,0
	je fals
	cmp al,28  ;;dc nr zile e mai mic ca 28, atunci sigur data e valida
	jle gata
	cmp al,31
	jg fals ;;daca o luna are mai mult de 31, atunci data nu e corecta
	cmp al,29 ;;mai mic nu poate fi
	jg test_30
	cmp ch,2   ;;deci aici nr zile e egal cu 29, si vedem dc e feb
	jne gata  ;;dc nu e feb e corect
	cmp dl,1  ;;stim k e feb, are 29 zile, si vedem dc e am bisect
	jne fals  ;;nu e an bisect, deci feb nu poate avea 29 zile
	jmp gata  ;;aici e an bisect, feb , 29 zile ,deci data e corecta
test_30:
	cmp al,30 ;;al mai poate fi doar 30 sau 31
	jg test_31 ;;dc e 31 sarim la a vedea dc luna are voie sa aiba 31
	cmp ch,2 ;;aici sunt 30 zile, si vedem dc nu cumva e feb
	je fals ;;dc e feb , data nu e corecta
	jmp gata ;;dc nu e feb, atunci avem o data corecta
test_31:
	cmp ch,1 ;;aici sunt 31 zile, vedem dc luna poate avea atatea
	jne fals
	jmp gata
fals:
	mov rez,1
gata:	
	pop di
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
ENDM

;;valideaza cnp dat ca un sir de 13 litere
;;prima trb sa fie 1 sau 2
;;apoi trb sa urmeze o data valida in format aallzz
;;iar apoi 6 cifre
;;rez este 0 dc cnp este valid
;;si 1 in caz contrar
cnp MACRO sir, rez
local fals, gata, test_cf
	data_aallzz sir[1],rez
	cmp rez, 0
	jne gata ;;rez este 1 
	mov si,7
	cmp sir[0],'1'
	je test_cf
	cmp sir[0],'2'
	jne fals	
test_cf:
	cmp sir[si],'0'
	jb fals
	cmp sir[si],'9'
	ja fals
	inc si
	cmp si,13
	jl test_cf
	jmp gata
fals:
	mov rez,1	
gata:
	pop si
ENDM